<?php

namespace WPDM\DropZone;

class DropZoneFile {
	private $tableName;

	public $ID = false;
	public $file;
	public $title;
	public $description;
	public $comments;
	public $owner;
	public $date;
	public $meta;
	public $status;

	public function __construct() {
		global $wpdb;
		$this->tableName = "{$wpdb->prefix}ahm_dropzone";
	}

	function get($id) {
		global $wpdb;
		$file = $wpdb->get_row($wpdb->prepare("SELECT * FROM {$this->tableName} WHERE id = %d", $id));
		if($file) {
			$this->ID = $file->ID;
			$this->file = $file->file;
			$this->title = $file->title;
			$this->description = $file->description;
			$this->comments = $file->comments;
			$this->owner = $file->owner;
			$this->date = $file->date;
			$this->meta = $file->meta;
			$this->status = $file->status;
		}
		return $this;
	}

	function addMeta( $name, $value ) {
		if(!is_object($this->meta))
			$this->meta = new \stdClass();
		$this->meta->$name = $value;
		return $this;
	}

	function save() {
		global $wpdb;
		$data = [
			'file' => $this->file,
			'title' => $this->title,
			'description' => $this->description,
			'comments' => json_encode($this->comments),
			'owner' => $this->owner,
			'date' => $this->date,
			'meta' => json_encode($this->meta),
			'status' => $this->status,
		];
		if($this->ID)
			$wpdb->update( $this->tableName, $data, ['ID' => $this->ID]);
		else
			$wpdb->insert( $this->tableName, $data);
	}

}
